//: C07:Stack2.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// převod kontejneru list na stack.
#include <iostream>
#include <fstream>
#include <stack>
#include <list>
#include <string>
#include <cstddef>
using namespace std;

// očekává se stack:
template<class Stk>
void stackOut(Stk& s, ostream& os = cout) {
  while(!s.empty()) {
    os << s.top() << "\n";
    s.pop();
  }
}

class Line {
  string line; // bez úvodních mezer
  size_t lspaces; // počet úvodních mezer
public:
  Line(string s) : line(s) {
    lspaces = line.find_first_not_of(' ');
    if(lspaces == string::npos)
      lspaces = 0;
    line = line.substr(lspaces);
  }
  friend ostream& operator<<(ostream& os, const Line& l) {
    for(size_t i = 0; i < l.lspaces; i++)
      os << ' ';
    return os << l.line;
  }
  // Zde budou další funkce...
};

int main() {
  ifstream in("Stack2.cpp");
  list<Line> lines;
  // Načíst soubor a uložit řádky do seznamu
  string s;
  while(getline(in, s))
    lines.push_front(s);
  // Kvůli tisku převést seznam na zásobník
  stack<Line, list<Line> > stk(lines);
  stackOut(stk);
} ///:~
